import { PAN_CARD, POLICE_FIR, EXTERNAL_DAMAGE, INTERNAL_DAMAGE, RC_BOOK, AADHAR_CARD, CNG, DRIVING_LICENSE, VIDEO_TITLE, SELFI_IMAGE, ODOMETER, VIDEO_URL } from './src/common/Constants'
import Orientation from 'react-native-orientation';
import { View, Text, StyleSheet, ScrollView, TouchableOpacity, TextInput, StatusBar, FlatList, Alert, PermissionsAndroid, ToastAndroid, Platform, Dimensions, ActivityIndicator } from 'react-native';
import React, { Component } from 'react';
import { Image } from 'react-native';
import Colors from './src/common/Colors'
import { RNCamera } from 'react-native-camera';
import Icon from 'react-native-vector-icons/FontAwesome';
import moment from 'react-moment'
import Geolocation from '@react-native-community/geolocation';
import VideoPlayer from 'react-native-video-player'
import { INSTRUCTIONS_URL, SELFSURVEYSERVICE_DOCUMENT_URL } from './src/Api/ApiUrls'
import RNFetchBlob from 'rn-fetch-blob'
import ViewShot from "react-native-view-shot";
import axios from 'axios'
import Upload from 'react-native-background-upload'
// import documentUploadData from './src/common/DocumentCollection'
import DeviceInfo from 'react-native-device-info';
import * as Progress from 'react-native-progress';
import status from './src/common/Status';
import {
    HideNavigationBar,
    ShowNavigationBar,
} from 'react-native-navigation-bar-color';
import PropTypes from 'prop-types';
import Marker from "react-native-image-marker"


const IMEI = require('react-native-imei');
const initial = Orientation.getInitialOrientation();
let SCREEN_WIDTH;
let SCREEN_HEIGHT;
if (initial === 'PORTRAIT') {
    SCREEN_HEIGHT = Math.round(Dimensions.get('window').width - 40)
    SCREEN_WIDTH = Math.round(Dimensions.get('window').height)
} else {
    SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
    SCREEN_WIDTH = Math.round(Dimensions.get('window').width)
}
const crossMark = require('./src/common/Image/crossMark.png')
const tickMark = require('./src/common/Image/tickMark.png')
let dynammicactivityId = ''


export default class Pre extends Component {


    static navigationOptions = {
        //To hide the NavigationBar from current Screen
        header: null
    };
    constructor(props) {
        super(props);
        this.state = ({
            isDisplayInstruction: true,
            torchon: '',
            isDisplayCameraPreview: false,
            isDisplayCamera: false,
            localPath: '',
            flashState: true,//for flash
            dateAndTime: '',//date and time
            currentLongitude: 'unknown',//Initial Longitude
            currentLatitude: 'unknown',//Initial Latitude
            isDisplayVideoRecorder: false,
            instructionData: '',
            fullDataSource: '',
            assets: '',
            header: '',
            count: 0,
            dataSource: '',
            cameraState: '',
            buttonText: '',
            skipdata: '',
            isBackButtonPressed: false,
            isSkipButtonPressed: false,
            extention: '',
            screenShotPath: '',
            isDisplayUploadDocument: false,
            upLoadIamgeDataSource: [],
            documentUploadPercentage: 0,
            odometerReading: '',
            ANDROID_ID: '',
            CurrentDate: '',
            showError: false,
            isLoading: true

        })

    }


    componentWillMount() {
        // The getOrientation method is async. It happens sometimes that
        // you need the orientation at the moment the JS runtime starts running on device.
        // `getInitialOrientation` returns directly because its a constant set at the
        // beginning of the JS runtime.

        if (initial === 'PORTRAIT') {
            // do something
            Orientation.lockToLandscapeLeft()//make landscape

        } else {
            // do something else

        }
    }

    componentDidMount() {
        PermissionsAndroid.requestMultiple(
            [PermissionsAndroid.PERMISSIONS.CAMERA,
            PermissionsAndroid.PERMISSIONS.READ_CONTACTS,
            PermissionsAndroid.PERMISSIONS.ACCESS_FINE_LOCATION,
            PermissionsAndroid.PERMISSIONS.ACCESS_COARSE_LOCATION,
            PermissionsAndroid.PERMISSIONS.READ_EXTERNAL_STORAGE,
            PermissionsAndroid.PERMISSIONS.READ_PHONE_STATE,
            PermissionsAndroid.PERMISSIONS.WRITE_EXTERNAL_STORAGE,]
        ).then((result) => {
            if (result['android.permission.ACCESS_COARSE_LOCATION']
                && result['android.permission.CAMERA']
                && result['android.permission.READ_CONTACTS']
                && result['android.permission.ACCESS_FINE_LOCATION']
                && result['android.permission.READ_PHONE_STATE']
                && result['android.permission.READ_EXTERNAL_STORAGE']
                && result['android.permission.WRITE_EXTERNAL_STORAGE'] === 'granted') {
                this.setState({
                    permissionsGranted: true
                });
                // DeviceInfo.getAndroidId().then(androidId => {
                //     this.setState({ ANDROID_ID: androidId })
                //   });
                console.log("Current Date :- " + Date.now())
                this.setState({ CurrentDate: Date.now() })

                DeviceInfo.getApiLevel().then(apiLevel => {

                    this.setState({ API_LEVEL: apiLevel })

                });

                if (this.state.API_LEVEL > 28) {
                    DeviceInfo.getAndroidId().then(androidId => {
                        this.setState({ ANDROID_ID: androidId })

                    });
                } else {
                    IMEI.getImei().then(imeiList => {
                        console.log("sssssssssssssssssssssssss" + imeiList)
                    });
                }
                DeviceInfo.getDeviceName().then(deviceName => {
                    this.setState({ DEVICE_NAME: deviceName })
                });

                DeviceInfo.getIpAddress().then(ip => {
                    this.setState({ IP: ip })
                });
                DeviceInfo.getMacAddress().then(mac => {
                    this.setState({
                        MAC: mac,
                    })
                });



                Orientation.lockToLandscapeLeft()

                // this locks the view to Landscape Mode
                // Orientation.lockToLandscape();

                // this unlocks any previous locks to all Orientations
                // Orientation.unlockAllOrientations();
                console.log("SH :- " + SCREEN_HEIGHT)
                console.log("SW :- " + SCREEN_WIDTH)

                Orientation.addOrientationListener(this._orientationDidChange);
                this.callLocation() //to get lat l
                this.callInstructionApi()

            } else if (result['android.permission.ACCESS_COARSE_LOCATION']
                || result['android.permission.CAMERA']
                || result['android.permission.READ_CONTACTS']
                || result['android.permission.ACCESS_FINE_LOCATION']
                || result['android.permission.READ_EXTERNAL_STORAGE']
                || result['android.permission.READ_PHONE_STATE']
                || result['android.permission.WRITE_EXTERNAL_STORAGE'] === 'never_ask_again') {
            }
        });
    }


    async callInstructionApi() {
        const instruction_url = INSTRUCTIONS_URL.replace('5', dynammicactivityId)
        let resp = await fetch(instruction_url)
        let resJson = await resp.json()
        // console.log("INSTRUCTIONS_URL" + resJson.TSurveySteps[0])

        this.setState({ instructionData: resJson.TSurveySteps })
        // console.log(resJson.activityTypeId)
        if (resJson.activityTypeId == 5) {                                     //WE HAVE TO CHANGE 5 TO 12
            this.renderDataToScreen()
        }

    }

    /*
**************************************************************************************************************
*/

    renderDataToScreen() {
        //condition check for the Front camera or Back camera
        if (this.state.count <= this.state.instructionData.length - 1 && this.state.count >= 0) {
            // if (this.state.count <= 2 && this.state.count >= 0) {

            console.log("COUNT: " + this.state.count)
            if (this.state.count <= this.state.instructionData.length - 1 && this.state.count >= 0) {
                // if (this.state.count <= 2 && this.state.count >= 0) {

                console.log("COUNT: " + this.state.count)
                if (this.state.instructionData[this.state.count].stepTitle == SELFI_IMAGE) {
                    this.setState({ cameraState: RNCamera.Constants.Type.front, isDisplayCamera: true, buttonText: 'Capture Images', extention: '.jpg', skipdata: this.state.instructionData[this.state.count].stepTitle })
                } else {
                    this.setState({ cameraState: RNCamera.Constants.Type.back, isDisplayCamera: true, buttonText: 'Capture Images', skipdata: this.state.instructionData[this.state.count].stepTitle, extention: '.jpg', rcbFront: this.state.instructionData[this.state.count].imageName })
                }

                if (this.state.instructionData[this.state.count].stepTitle == VIDEO_TITLE) {
                    this.setState({
                        assets: "https://d2h44aw7l5xdvz.cloudfront.net/videos/self-inspection-for-car.mp4",
                        isDisplayVideoRecorder: true,
                        isDisplayCameraPreview: false,
                        isDisplayCamera: false,
                        buttonText: 'Capture Video',
                        extention: '.mp4',
                        skipdata: this.state.instructionData[this.state.count].stepTitle
                    })
                }
                this.setState({
                    assets: this.state.instructionData[this.state.count].stepAssests,//Image Url
                    header: this.state.instructionData[this.state.count].stepTitle,//Header for screen
                    subheader: this.state.instructionData[this.state.count].description,//subheader
                    dataSource: this.state.instructionData[this.state.count].TSurveyInstructions,//data to flatList
                })
            }
        }
    }
    /*
**************************************************************************************************************
*/
    captureButton() {
        //condition for Skip Documents
        if (this.state.skipdata == PAN_CARD || this.state.skipdata == AADHAR_CARD || this.state.skipdata == CNG ||
            this.state.skipdata == POLICE_FIR || this.state.skipdata == EXTERNAL_DAMAGE || this.state.skipdata == INTERNAL_DAMAGE ||
            this.state.skipdata == DRIVING_LICENSE || this.state.rcbFront == 'RCB2') {
            return (
                <View style={{ flex: 1, flexDirection: 'row' }}>
                    <View style={{ flex: 0.45 }}>
                        <TouchableOpacity onPress={() => [this.setState({ isDisplayInstruction: false })]}>
                            <View style={styles.captureImageButtonView}>
                                <Text style={styles.captureImageButtonText}>Capture</Text>
                            </View>
                        </TouchableOpacity>
                    </View>
                    <View style={{ flex: 0.1 }}></View>
                    <View style={{ flex: 0.45 }}>
                        <TouchableOpacity onPress={() => [this.setState({ isSkipButtonPressed: true }), this.increseCount()]}>
                            <View style={styles.captureImageButtonView}>
                                <Text style={styles.captureImageButtonText}>Skip</Text>
                            </View>
                        </TouchableOpacity>
                    </View>
                </View>
            )
        } else {
            return (
                <TouchableOpacity onPress={() => this.validate()}>
                    <View style={styles.captureImageButtonView}>
                        <Text style={styles.captureImageButtonText}>{this.state.buttonText}</Text>
                    </View>
                </TouchableOpacity>
            )
        }


    }
    validate() {
        if (this.state.skipdata == ODOMETER) {
            if (this.state.odometerReading != '') {
                this.setState({ isDisplayInstruction: false, showError: false, odometerReading: '' })
            } else {
                this.setState({ isDisplayInstruction: true, showError: true })

            }
        } else {
            this.setState({ isDisplayInstruction: false })
        }
    }

    /*
**************************************************************************************************************
*/

    callLocation() {
        //alert("callLocation Called");
        Geolocation.getCurrentPosition(
            //Will give you the current location
            (position) => {
                const longitude = JSON.stringify(position.coords.longitude);
                //getting the Longitude from the location json
                const latitude = JSON.stringify(position.coords.latitude);
                //getting the Latitude from the location json
                this.setState({ currentLongitude: longitude });
                //Setting state Longitude to re re-render the Longitude Text
                this.setState({ currentLatitude: latitude });
                //Setting state Latitude to re re-render the Longitude Text
            },
            { enableHighAccuracy: true, timeout: 20000, maximumAge: 1000 }
        );
        this.watchID = Geolocation.watchPosition((position) => {
            //Will give you the location on location change
            console.log(position);
            const longitude = JSON.stringify(position.coords.longitude);
            //getting the Longitude from the location json
            const latitude = JSON.stringify(position.coords.latitude);
            //getting the Latitude from the location json
            this.setState({ currentLongitude: longitude });
            //Setting state Longitude to re re-render the Longitude Text
            this.setState({ currentLatitude: latitude });
            //Setting state Latitude to re re-render the Longitude Text
        });
    }
    /*
    **************************************************************************************************************
    */
    _orientationDidChange = (orientation) => {
        if (orientation === 'LANDSCAPE') {
            // do something with landscape layoutr
            SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
            SCREEN_WIDTH = Math.round(Dimensions.get('window').width)

        } else {
            // do something with portrait layout   
            SCREEN_HEIGHT = Math.round(Dimensions.get('window').width)
            SCREEN_WIDTH = Math.round(Dimensions.get('window').height)
        }
    }
    /*
    **************************************************************************************************************
    */
    componentWillUnmount() {
        Orientation.getOrientation((err, orientation) => {
            console.log(`Current Device Orientation: ${orientation}`);//display currrent location state

        });


        // Remember to remove listener
        Orientation.removeOrientationListener(this._orientationDidChange);
        Geolocation.clearWatch(this.watchID);//For GeoLocation

    }
    /*
    **************************************************************************************************************
    */

    /*
                               %%%%%%%%%%%%% For Take Picture %%%%%%%%%%%%%%%%
    */
    takePicture = async function (camera) {
        const options = { quality: 0.2, base64: true };
        const data = await camera.takePictureAsync(options);
        //  eslint-disable-next-line
        this.setState({
            localPath: data.uri,
            cameraData: data,
            isDisplayCameraPreview: true,
            isDisplayCamera: false
        })//path of photo

        // console.log(data);//path of photo


        this.watermarkLocation()
        //Date calulation for the display on preciew Screen
        const date = new Date().getDate();
        const month = new Date().getMonth() + 1;
        const year = new Date().getFullYear();

        //Time calulation for the display on preciew Screen
        const hour = new Date().getHours();
        const minute = new Date().getMinutes();
        const seconds = new Date().getSeconds();
        //Alert.alert(date + '-' + month + '-' + year);
        // You can turn it in to your desired format
        this.setState({ dateAndTime: date + '-' + month + '-' + year + "  " + hour + ':' + minute + ':' + seconds })//format: dd-mm-yyyy;

    }
    watermarkLocation() {
        return (
            Marker.markText({
                src: this.state.localPath,
                text: 'lat: ' + this.state.currentLatitude + " " + "long: " + this.state.currentLongitude,
                position: 'topLeft',
                fontName: 'Muli-Regular',
                fontSize: 30,
                scale: 1,
                quality: 100,
                color: Colors.digitYellow,

            }).then((res) => {
                this.setState({
                    markLocationResult: 'file://' + res
                })
                console.log("the path is" + this.state.markLocationResult)
                this.watermarkDigitEdge()


            }).catch((err) => {
                console.log(err)
                this.setState({
                    err
                })
            })

            // <Image
            //     source={this.state.ress}
            //     style={{ width: 500, height: 500, backgroundColor: 'blue' }}
            // />
        );
    }

    watermarkDigitEdge() {
        return (
            Marker.markText({
                src: this.state.markLocationResult,
                text: 'Digit Edge',
                position: 'topRight',
                fontName: 'Muli-Regular',
                fontSize: 30,
                scale: 1,
                quality: 100,
                color: Colors.digitYellow,

            }).then((res) => {
                this.setState({
                    markDigitEdgeResult: 'file://' + res,
                })
                console.log("the path is" + this.state.markDigitEdgeResult)

                this.finalWatermark()
            }).catch((err) => {
                console.log(err)
                this.setState({
                    err
                })
            })

        );
    }

    finalWatermark() {
        return (
            Marker.markText({
                src: this.state.markDigitEdgeResult,
                text: this.state.dateAndTime,
                position: 'bottomLeft',
                fontName: 'Muli-Regular',
                fontSize: 30,
                scale: 1,
                quality: 30,
                color: Colors.digitYellow,

            }).then((res) => {
                this.setState({
                    finalWatermarkResult: 'file://' + res,
                    // isLoading: false

                })
                console.log("the path is" + this.state.finalWatermarkResult)
            }).catch((err) => {
                console.log(err)
                this.setState({
                    err
                })
            })

        );
    }
    /*
**************************************************************************************************************
*/


    /*
                                 %%%%%%%%%%%%% For Video Record %%%%%%%%%%%%%%%%
      */

    async startRecording() {
        this.setState({ recording: true });
        // default to mp4 for android as codec is not set
        const options = { quality: 0.2, base64: true };
        const { uri, codec = "mp4" } = await this.camera.recordAsync(options);
        this.setState({ localPath: uri })
        console.log(this.state.localPath)


    }

    //Stop Recording
    stopRecording() {
        this.camera.stopRecording();
        this.setState({ isDisplayVideoPlayer: true, isDisplayVideoRecorder: false })
        this.setState({ recording: false });
    }



    /*
******************************** for creating  floder at local storage*************************************
    */
    async createFloder(activityId, activityTypeId) {


        console.log(this.state.count)

        const POSP = RNFetchBlob.fs.dirs.SDCardDir + '/POSP/';//Create Floder in External storage
        this.setState({ FilePath: POSP })
        let exists = await RNFetchBlob.fs.exists(POSP) // checkExist 
        if (exists) {
            let isDir = await RNFetchBlob.fs.isDir(POSP);
            if (isDir) {
                // Permission for storage
                const granted = await PermissionsAndroid.request(
                    PermissionsAndroid.PERMISSIONS.WRITE_EXTERNAL_STORAGE,
                    {
                        title: 'Read Internal Storage',
                        message: 'Read Internal Storage',
                        buttonPositive: 'Ok',
                        buttonNegative: 'Cancle'
                    }
                )
                if (granted) {
                    // if Granted
                    const Image_Name = activityId + this.state.instructionData[this.state.count - 1].imageName + this.state.extention //Image NAme with Extension
                    this.setState({ imageName: Image_Name })
                    console.log(this.state.imageName)
                    await RNFetchBlob.fs.writeFile(POSP + Image_Name, 'base64');
                    // let _copy = await RNFetchBlob.fs.cp(this.state.screenShotPath, POSP + Image_Name);
                    let _copy = await RNFetchBlob.fs.cp(this.state.finalWatermarkResult, POSP + Image_Name);

                    RNFetchBlob.fs.stat(this.state.FilePath + this.state.imageName)
                        .then((stats) => {
                            console.log("FileName: " + stats.filename)
                            console.log("FileSize: " + stats.size)
                            console.log("type: " + stats.type)
                            console.log("lastModified: " + stats.lastModified)
                            this.setState({ fileSize: stats.size })
                        })
                        .catch((err) => {

                        })
                    this.uploadImage(activityId, activityTypeId)

                } else {
                    // ask Permission
                    this.createFloder()
                }
            }
        } else {
            //IF not then create floder
            RNFetchBlob.fs
                .mkdir(POSP)
                .catch(err => {
                    console.log(err);
                });
            this.createFloder()
        }

    }


    /*
    **************************************************************************************************************
    */


    // For Flash
    toggleTorch() {
        if (this.state.flashState == true) {
            console.log('AUTO')
            this.setState({ flashState: false })
        } else {
            this.setState({ flashState: true })
            console.log('ON')


        }
    }

    /*
    **************************************************************************************************************
    */


    flatListOrNot() {
        if (this.state.skipdata != ODOMETER) {
            return (
                <View style={styles.infoScrollView}>
                    <ScrollView>
                        <FlatList
                            data={this.state.dataSource}
                            renderItem={this.renderItem}
                            style={{ fontFamily: 'Mulli-Regular', }}
                        />
                    </ScrollView>
                </View>
            )
        } else {
            return (
                <View>
                    <View style={styles.infoScrollViewWithTextInput}>
                        <ScrollView>
                            <FlatList
                                data={this.state.dataSource}
                                renderItem={this.renderItem}
                            />
                        </ScrollView>
                    </View>
                    <Text style={styles.odometerText}>Odometer Reading:</Text>
                    <TextInput
                        style={styles.odometerInputText}
                        keyboardType='numeric'
                        onChangeText={odometerReading => this.setState({ odometerReading })}
                    />
                    {this.showErrorText()}

                </View>
            )
        }
    }
    showErrorText() {
        if (this.state.showError) {
            return (
                <Text style={{ color: 'red', marginLeft: 4, fontFamily: 'Muli-Regular' }}>Enter Odometer Reading</Text>
            )
        }

    }

    /*
    **************************************************************************************************************
    */


    //Display Data in FlatList
    renderItem = ({ item }) => (
        <Text style={styles.instructionText}>{'\u2B24'} {item.instructionData}</Text>
    )

    /*
     **************************************************************************************************************
*/
    uploadedDocumentStatus = ({ item }) => (
        <View>
            <View style={{ margin: 16, width: SCREEN_HEIGHT, height: SCREEN_WIDTH / 8.5, flexDirection: 'row' }}>
                <View style={{ flex: 0.2 }}>
                    {this.uploadedDocumentImageOrVideo(item)}
                </View>
                <View style={{ flex: 0.03, justifyContent: 'center' }}>

                </View>
                <View style={{ flex: 0.77, }}>
                    <View style={{ flex: 0.45, justifyContent: 'center' }}>
                        <Text>{item.stepTitle}</Text>
                    </View>
                    <View style={{ flex: 0.15, justifyContent: 'center' }}>
                        <Text>{(item.imageSize / 1024).toString().split('.')[0]} KB</Text>
                    </View>
                    <View style={{ flex: 0.15, justifyContent: 'center' }}>
                        <Progress.Bar progress={item.upLoadStatus} width={SCREEN_HEIGHT / 1.5} color={Colors.digitYellow} height={2} borderColor={'white'} />
                    </View>
                    <View style={{ flex: 0.25, justifyContent: 'center' }}>
                        <Text style={{ color: Colors.digitYellow }}>{item.upLoadStatus * 100} % Completed</Text>
                    </View>

                </View>

            </View>
            <View style={{ borderRadius: 1, width: SCREEN_WIDTH, height: 1, borderWidth: 0.5, color: Colors.borderBlack }}></View>

        </View>
    )
    //Checking the document image or Video
    uploadedDocumentImageOrVideo(item) {
        const type = item.imagePath.split('.')
        if (type[3] == 'mp4') {
            return (
                <VideoPlayer
                    video={{ uri: item.imagePath }}
                    pauseOnPress={true}
                    autoplay={true}
                    disableSeek={true}
                    style={{ flex: 1, resizeMode: 'contain' }}


                >
                </VideoPlayer>
            )

        } else {
            return (
                <Image
                    source={{ uri: item.imagePath }}
                    resizeMethod='auto'
                    resizeMode='contain'
                    style={{ flex: 1, resizeMode: 'contain' }}

                />
            )
        }

    }
    //Display image or video
    imageOrVideo() {

        if (this.state.assets == VIDEO_URL && this.state.isDisplayVideoRecorder == true) {
            return (
                <VideoPlayer
                    video={{ uri: "https://d2h44aw7l5xdvz.cloudfront.net/videos/self-inspection-for-car.mp4" }}
                    videoHeight={SCREEN_HEIGHT}
                    videoWidth={SCREEN_WIDTH}
                    pauseOnPress={true}
                    autoplay={true}
                    disableSeek={true}
                    style={styles.productImageStyle}

                >
                </VideoPlayer>
            )

        } else {
            return (
                <Image
                    source={{ uri: this.state.assets }}
                    style={styles.productImageStyle}
                    resizeMethod='auto'
                    resizeMode='contain'
                />
            )
        }
    }

    /*
**************************************************************************************************************
*/

    //reduce the count
    reduceCount() {
        if (this.state.count >= 1) {
            this.setState({
                count: this.state.count - 1
            })
        }
        setInterval(() => {
            if (this.state.isBackButtonPressed == true) {
                this.renderDataToScreen()
            }
            this.setState({ isBackButtonPressed: false })
        }, 100);

    }

    /*
    **************************************************************************************************************
*/
    //increase the count
    increseCount() {

        if (this.state.count <= this.state.instructionData.length) {
            this.setState({
                count: this.state.count + 1
            })
        }
        setInterval(() => {
            if (this.state.isSkipButtonPressed == true) {
                this.renderDataToScreen()
            }
            this.setState({ isSkipButtonPressed: false })
        }, 100);
    }

    /*
      **************************************************************************************************************
      */

    //Load after screen shot 
    // onImageLoad = () => {
    //     this.setState({ isImageLoad: true })
    //     setInterval(() => {
    //         if (this.state.isImageLoad == true) {

    //             this.refs.viewShot.capture().then(uri => {
    //                 this.setState({ screenShotPath: uri })
    //                 console.log("do something with ", this.state.screenShotPath);

    //             })

    //         }
    //         this.setState({ isImageLoad: false })
    //     }, 300);
    // };

    /*
    **************************************************************************************************************
    */

    //upload images
    uploadImage(activityId) {
        const documentUploadData = {

            "activityId": activityId,
            "documentSource": "DigitEdge",
            "geoLocation": {
                "deviceIMEI": this.state.ANDROID_ID,
                "deviceName": this.state.DEVICE_NAME,
                "deviceTime": this.state.CurrentDate,
                "documentSource": "DigitEdge",
                "ipAddress": this.state.IP,
                "isBlocked": false,
                "latitude": this.state.currentLatitude,
                "longitude": this.state.currentLongitude,
                "macAddress": this.state.MAC,
                "operatingSystem": this.state.VERSION,
                "timezone": "Asia/Kolkata"
            },
            "isLast": false,
            "isLastData": false,
            "isLastDocument": false,
            "isSurveyor": false,
            "manualOdometerReading": "",
            "source": "DIGITEDGE"
        }

        RNFetchBlob.fetch('POST', SELFSURVEYSERVICE_DOCUMENT_URL, {
            'Content-Type': 'multipart/form-data',
        }, [
            // element with property `filename` will be transformed into `file` in form data
            //file name is Original file name
            { name: 'file', filename: this.state.imageName, type: 'image/jpg', data: this.state.FilePath + this.state.imageName },
            { name: 'documentData', data: JSON.stringify(documentUploadData) },
        ])
            .uploadProgress({ interval: 250 }, (written, total) => {
                console.log('Written', written)
                console.log('total', total)
                console.log('uploaded', written / total)
                this.setState({ documentUploadPercentage: (written / total) })


            })
            // listen to download progress event, every 10%
            .progress({ count: 10 }, (received, total) => {
                console.log('progress', received / total)
                // let isExisist = this.state.upLoadIamgeDataSource.find(this.state.upLoadIamgeDataSource.stepTitle == this.state.instructionData[this.state.count - 1].stepTitle)

                this.state.upLoadIamgeDataSource.push({

                    imagePath: 'file://' + this.state.FilePath + this.state.imageName,
                    stepTitle: this.state.instructionData[this.state.count - 1].stepTitle,
                    imageSize: this.state.fileSize,
                    upLoadStatus: this.state.documentUploadPercentage,

                });

                if (this.state.count == this.state.instructionData.length) {
                    // if (this.state.count == 3) {
                    console.log(this.state.count)
                    this.setState({ isDisplayUploadDocument: true, isDisplayInstruction: false, isDisplayCameraPreview: false, isDisplayVideoRecorder: false })
                }

                console.log("!!!!!!!!!!!!!!!!!!!!!!!!!!!!" + this.state.upLoadIamgeDataSource.length)
            })

            .then((response) => {
                console.log("******************** resp: " + JSON.stringify(response))
            }).catch((err) => {
                console.log("******************** err: " + JSON.stringify(err))
            })
        this.renderDataToScreen()

    }



    render() {
        const {
            activityId,
            activityTypeId
        } = this.props;
        //************************** Insruction Screen*************************************** */
        // { console.log("activityId from user" + activityId) }
        // { console.log("activityTypeId from user" + activityTypeId) }

        //Activity ID
        dynammicactivityId = activityTypeId

        if (this.state.isDisplayInstruction == true) {

            return (
                <View style={styles.main}>
                    {console.disableYellowBox = true}
                    <StatusBar
                        hidden={true}
                    />

                    <View style={styles.productImageView}>
                        <View style={styles.backButtonImageView}>
                            <TouchableOpacity onPress={() => [this.setState({ isBackButtonPressed: true, }), this.reduceCount()]}>
                                <Icon
                                    name="arrow-left"
                                    size={25}
                                    style={{ marginLeft: 16 }}
                                />
                            </TouchableOpacity>


                        </View>
                        <View >
                            {this.imageOrVideo()}
                        </View>
                    </View>

                    <View style={styles.blankView}>
                        <View style={styles.headerView}>
                        </View>
                    </View>

                    <View style={styles.productInfoView}>
                        <View style={styles.headerView}>
                            <Text style={styles.headerText}>
                                {/* header text */}
                                {this.state.header}
                            </Text>
                        </View>
                        <View style={styles.subHeaderTextView}>
                            <Text style={styles.subHeaderText}>
                                {/* Subheader text */}
                                {this.state.subheader}
                            </Text>
                        </View>
                        {this.flatListOrNot()}
                        {this.captureButton()}
                    </View>
                </View>
            )
        }
        //**************************camera Screen*************************************** */

        if (this.state.isDisplayCamera == true) {
            SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
            SCREEN_WIDTH = Math.round(Dimensions.get('window').width)
            return (

                <View style={styles.container}>

                    <StatusBar
                        hidden={true}
                    />
                    <RNCamera
                        style={styles.preview}
                        type={this.state.cameraState}
                        flashMode={this.state.flashState
                            ? RNCamera.Constants.FlashMode.auto
                            : RNCamera.Constants.FlashMode.off
                        }
                        androidCameraPermissionOptions={{
                            title: 'Permission to use camera',
                            message: 'We need your permission to use your camera',
                            buttonPositive: 'Ok',
                            buttonNegative: 'Cancel',
                        }}
                        androidRecordAudioPermissionOptions={{
                            title: 'Permission to use audio recording',
                            message: 'We need your permission to use your audio',
                            buttonPositive: 'Ok',
                            buttonNegative: 'Cancel',
                        }}
                        // pausePreview={true}
                        // pauseAfterCapture={true}
                        autoFocus={true}


                    >

                        {({ camera, status, recordAudioPermissionStatus }) => {
                            // if (status !== 'READY') return <PendingView />;
                            return (
                                <View style={{ flex: 1, position: 'absolute', width: SCREEN_WIDTH, height: SCREEN_HEIGHT }}>
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', left: 1 }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', left: 1, bottom: 1 }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', right: 1, bottom: 1 }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', right: 1 }}
                                    />

                                    <Image
                                        source={{ uri: this.state.instructionData[this.state.count].stepStencilAssests }}
                                        style={{ width: SCREEN_WIDTH - 50, height: SCREEN_HEIGHT, position: 'absolute', marginRight: 15, marginLeft: 15, resizeMode: 'contain' }}
                                    />
                                    <View style={{ flex: 1 }}>
                                        <View style={{ flex: 0.5, justifyContent: 'flex-end' }}>
                                            <TouchableOpacity onPress={() => [this.takePicture(camera)]} style={styles.capture}>
                                                {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                                                <Icon
                                                    name="camera"
                                                />
                                            </TouchableOpacity>
                                        </View>
                                        <View style={{ flex: 0.5 }}>
                                            <TouchableOpacity onPress={() => [this.toggleTorch()]} style={styles.flash}>
                                                {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                                                <Icon
                                                    name="flash"
                                                />
                                            </TouchableOpacity>
                                        </View>
                                    </View>

                                </View>
                            );

                        }}

                    </RNCamera>

                </View>
            );
        }
        //     //************************** camera Preview Screen *************************************** */

        if (this.state.isDisplayCameraPreview == true) {
            SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
            SCREEN_WIDTH = Math.round(Dimensions.get('window').width)
            console.log("SH :- " + SCREEN_HEIGHT)
            console.log("SW :- " + SCREEN_WIDTH)


            return (
                <View style={{ flex: 1, flexDirection: 'row' }}>
                    <StatusBar
                        hidden={true}
                    />
                    <View style={{ flex: 0.95, backgroundColor: 'black' }}>
                        <Image
                            source={{ uri: this.state.finalWatermarkResult }}
                            style={styles.previewImageStyle}
                        />
                    </View>
                    <View style={styles.previewImageIconMainView}>
                        <View style={styles.tickMarkImageView}>
                            {/* for video camera opening */}
                            <TouchableOpacity onPress={() => [this.setState({ isDisplayInstruction: true, isDisplayCamera: false, count: this.state.count + 1, isLoading: true }), this.createFloder(activityId, activityTypeId)]}>
                                <Image
                                    source={tickMark}
                                    style={styles.tickMarkImageStyle}
                                />
                            </TouchableOpacity>

                        </View>

                        <View style={styles.crossImageView}>
                            <TouchableOpacity onPress={() => this.setState({ isDisplayCamera: true, isLoading: true })}>
                                <Image
                                    source={crossMark}
                                    style={styles.crossImageStyle}
                                />
                            </TouchableOpacity>

                        </View>
                    </View>

                </View>
            )


        }
        //     //**************************Video Recorder*************************************** */
        if (this.state.isDisplayVideoRecorder == true) {
            const { recording, processing } = this.state;

            let button = (
                <View style={{ flex: 1, position: 'absolute', width: SCREEN_WIDTH, height: SCREEN_HEIGHT }}>
                    <View style={{ flex: 0.5, justifyContent: 'flex-end' }}>
                        <TouchableOpacity onPress={() => [this.startRecording()]} style={styles.capture}>
                            {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                            <Icon
                                name="video-camera"
                            />
                        </TouchableOpacity>
                    </View>

                </View>
            );

            if (recording) {
                button = (
                    <View style={{ flex: 1, position: 'absolute', width: SCREEN_WIDTH, height: SCREEN_HEIGHT }}>
                        <View style={{ flex: 0.5, justifyContent: 'flex-end' }}>
                            <TouchableOpacity onPress={() => [this.stopRecording()]} style={styles.capture}>
                                {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                                <Icon
                                    name="video-off-outline"
                                />
                            </TouchableOpacity>
                        </View>

                    </View>
                );
            }
            return (
                <View style={styles.container}>
                    <StatusBar
                        hidden={true}
                    />
                    <RNCamera
                        ref={ref => {
                            this.camera = ref;
                        }}
                        style={styles.preview}
                        type={RNCamera.Constants.Type.back}
                        flashMode={RNCamera.Constants.FlashMode.on}
                        permissionDialogTitle={"Permission to use camera"}
                        permissionDialogMessage={
                            "We need your permission to use your camera phone"
                        }
                    >

                        {({ camera, status, recordAudioPermissionStatus }) => {
                            // if (status !== 'READY') return <PendingView />;
                            return (

                                <View style={{ flex: 1, position: 'absolute', width: SCREEN_WIDTH, height: SCREEN_HEIGHT }}>
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', left: 1, }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', left: 1, bottom: 1, }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', right: 1, bottom: 1, }}
                                    />
                                    <Image
                                        source={crossMark}
                                        style={{ width: 50, height: 50, position: 'absolute', right: 1 }}
                                    />
                                    {button}

                                </View>
                            );

                        }}
                    </RNCamera>

                </View>
            );
        }
        //             //**************************Video Player*************************************** */

        if (this.state.isDisplayVideoPlayer == true) {

            return (

                <View>
                    <StatusBar
                        hidden={true}
                    />

                    <VideoPlayer
                        video={{ uri: this.state.localPath }}
                        videoWidth={SCREEN_WIDTH}
                        videoHeight={SCREEN_HEIGHT}
                        pauseOnPress={true}
                        seekBarWidth={5}
                    >
                    </VideoPlayer>
                    {/* Buttons on video player */}
                    <View style={{ position: 'absolute', left: 10, bottom: 50 }}>
                        <TouchableOpacity onPress={() => this.setState({ isDisplayVideoRecorder: true })}>
                            <Text style={{ backgroundColor: Colors.digitYellow, paddingTop: 3, paddingBottom: 3, paddingLeft: 6, paddingRight: 6, borderRadius: 4 }}>RETRY</Text>
                        </TouchableOpacity>
                    </View>
                    {/* Buttons on video player */}

                    <View style={{ position: 'absolute', right: 10, bottom: 50 }}>
                        <TouchableOpacity onPress={() => [this.setState({ isDisplayVideoPlayer: false, isDisplayInstruction: true, isDisplayVideoRecorder: false, count: this.state.count + 1 }), this.createFloder(activityId, activityTypeId)]}>
                            <Text style={{ backgroundColor: Colors.digitYellow, paddingTop: 3, paddingBottom: 3, paddingLeft: 6, paddingRight: 6, borderRadius: 4 }}>SUBMIT</Text>
                        </TouchableOpacity>
                    </View>

                </View>
            )
        }

        //////////////////////////////////////////////////////////////////////////////
        if (this.state.isDisplayUploadDocument == true) {

            // do something
            Orientation.lockToPortrait()
            Orientation.addOrientationListener(this._orientationDidChange);

            return (

                <View>
                    <StatusBar
                        hidden={true}
                    />
                    <View style={styles.documentProcessView}>
                        <Text style={styles.documentProcessHeader}>Document being processd!</Text>
                    </View>
                    <View style={{ width: SCREEN_WIDTH, height: SCREEN_WIDTH }}>
                        <FlatList
                            data={this.state.upLoadIamgeDataSource}
                            keyExtractor={(item, index) => item.index}
                            renderItem={this.uploadedDocumentStatus}
                            maxToRenderPerBatch={100}
                            updateCellsBatchingPeriod={1000}
                            style={{
                                backgroundColor: 'white', marginBottom: 40, fontFamily: 'Mulli-Regular',
                            }}
                        />
                    </View>


                </View>



            )
        }
    }
}

Pre.propTypes = {
    activityId: PropTypes.object,
    activityTypeId: PropTypes.object,
};

Pre.defaultProps = {
    activityId: '',
    activityTypeId: '',

};
const styles = StyleSheet.create({
    main: {
        flex: 1,
        flexDirection: 'row',
        backgroundColor: '#FFFFFF'
    },
    productImageView: {
        flex: 0.475,
    },
    blankView: {
        flex: 0.05,
    },
    productInfoView: {
        flex: 0.475,
        width: SCREEN_WIDTH,
        height: SCREEN_HEIGHT
    },
    headerView: {
        backgroundColor: '#F5F5F5',
        height: 60,
        justifyContent: 'center'
    },
    headerText: {
        marginLeft: 16,
        fontSize: 16,
        fontFamily: 'Muli-Black',
        marginRight: 16
    },
    documentProcessHeader: {
        marginLeft: 16,
        fontSize: 26,
        fontFamily: 'Muli-Black',
        marginRight: 16,
        justifyContent: 'center'
    },
    documentProcessView: {
        width: SCREEN_WIDTH,
        height: 60,
        justifyContent: 'center',
        backgroundColor: '#F5F5F5'
    },
    productImageStyle: {
        marginTop: 8,
        marginLeft: 16,
        marginBottom: 40,
        height: SCREEN_HEIGHT - 70,

    },
    backButtonImageStyle: {
        marginLeft: 32,
        height: 30,
        width: 40,
        backgroundColor: 'red'
    },
    subHeaderText: {
        fontFamily: 'Mulli-Regular',
        fontSize: 16,
        marginLeft: 16,
        marginRight: 16

    },
    instructionText: {
        fontFamily: 'Mulli-Regular',
        fontSize: 16,
        marginLeft: 32,
        marginBottom: 20,
        marginRight: 16

    },
    captureImageButtonView: {
        height: 48,
        borderRadius: 4,
        backgroundColor: Colors.digitYellow,
        marginTop: 2,
        flexDirection: 'row',
        justifyContent: 'center',
        marginRight: 16

    },
    captureImageButtonText: {
        fontSize: 16,
        fontFamily: 'Muli-Black',
        alignSelf: 'center'
    },
    container: {
        flex: 1,
        // flexDirection: 'row',
        // backgroundColor: 'black',
    },
    preview: {
        flex: 1,
        justifyContent: 'flex-end',
        alignItems: 'center',
    },
    capture: {
        flex: 0,
        backgroundColor: '#fff',
        borderRadius: 5,
        padding: 15,
        paddingHorizontal: 20,
        alignSelf: 'flex-end',
        margin: 20,
        position: 'absolute'
    },
    flash: {
        flex: 0,
        backgroundColor: '#fff',
        borderRadius: 5,
        padding: 15,
        paddingHorizontal: 20,
        alignSelf: 'flex-end',
        margin: 20,
        position: 'absolute'
    },
    previewImageStyle: {
        width: SCREEN_WIDTH,
        height: SCREEN_HEIGHT,
        resizeMode: 'contain'
    },
    dateAndTimeText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        left: 1,
        bottom: 1
    },
    previewImageIconMainView: {
        flex: 0.05,
        backgroundColor: 'black'
    },
    tickMarkImageView: {
        flex: 0.6,
        justifyContent: 'flex-end'
    },
    tickMarkImageStyle: {
        width: 30,
        height: 30,
        backgroundColor: 'white',
        alignSelf: 'center',
        marginBottom: 20
    },
    crossImageView: {
        flex: 0.4,
        justifyContent: 'flex-end',
        marginBottom: 20
    },
    crossImageStyle: {
        width: 30,
        height: 30,
        backgroundColor: 'white',
        alignSelf: 'center',
    },
    cameraIconView: {
        flexDirection: 'row',
        justifyContent: 'center',
        width: SCREEN_WIDTH,
        position: 'absolute'
    },
    infoScrollView: {
        marginTop: 40,
        height: SCREEN_HEIGHT - 220
    },
    subHeaderTextView: {
        height: 40,
        marginTop: 8
    },
    backButtonImageView: {
        backgroundColor: '#F5F5F5',
        height: 60,
        justifyContent: 'center',
    },
    latLongText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        left: 1,
    },
    digitEdgeText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        right: 1,
    },
    odometerText: {
        fontSize: 16,
        fontFamily: 'Muli-Black',
        marginLeft: 16,
    },
    odometerInputText: {
        fontSize: 16,
        fontFamily: 'Muli-Black',
        borderRadius: 4,
        borderColor: Colors.digitYellow,
        borderWidth: 1,
        marginTop: 5,
        marginRight: 16,
        marginBottom: 5
    },
    infoScrollViewWithTextInput: {
        height: SCREEN_HEIGHT - 270
    }



});
