import { SCREEN_HEIGHT, SCREEN_WIDTH } from './Constants'
import Orientation from 'react-native-orientation';
import { View, Text, StyleSheet, ScrollView, TouchableOpacity, StatusBar } from 'react-native';
import React, { Component } from 'react';
import { Image } from 'react-native';
import Colors from './Colors'
import { RNCamera } from 'react-native-camera';
import Icon from 'react-native-vector-icons/FontAwesome';
import moment from 'react-moment'
import Geolocation from '@react-native-community/geolocation';

export default class DocumentCollection extends Component {
    constructor(props) {
        super(props);
        this.state = ({
            isPressed: false,
            torchon: '',
            isDisplayPreview: false,
            localPath: '',
            flashState: true,
            dateAndTime: '',
            currentLongitude: 'unknown',//Initial Longitude
            currentLatitude: 'unknown',//Initial Latitude
        })
    }

    render() {
        let Image_Http_URL = { uri: 'https://reactjs.org/logo-og.png' };
        return (
            <View style={styles.main}>
                <StatusBar
                    hidden={true}
                />

                <View style={styles.productImageView}>
                    <View style={styles.backButtonImageView}>
                        <Image
                            style={styles.backButtonImageStyle}
                        />
                    </View>
                    <View>
                        <Image
                            source={Image_Http_URL}
                            style={styles.productImageStyle}

                        />
                    </View>
                </View>

                <View style={styles.blankView}>
                    <View style={styles.headerView}>

                    </View>
                </View>

                <View style={styles.productInfoView}>
                    <View style={styles.headerView}>
                        <Text style={styles.headerText}>
                            Front of the bike
            </Text>
                    </View>
                    <View style={styles.subHeaderTextView}>
                        <Text style={styles.subHeaderText}>
                            Take shot of the front of the bike.Get the whole bike in picture,including:
            </Text>
                    </View>
                    <View style={styles.infoScrollView}>
                        <ScrollView>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>
                            <Text style={styles.instructionText}>{'\u2B24'} Headlight (lamp) and turn signal lamp (winkers)</Text>

                        </ScrollView>
                    </View>

                    <TouchableOpacity onPress={() => this.props.screenProps.setPressed(true)}>
                        <View style={styles.captureImageButtonView}>
                            <Text style={styles.captureImageButtonText}>Capture Image</Text>
                        </View>
                    </TouchableOpacity>

                </View>


            </View>
        )
    }

}

const styles = StyleSheet.create({
    main: {
        flex: 1,
        flexDirection: 'row'
    },
    productImageView: {
        flex: 0.475,
    },
    blankView: {
        flex: 0.05,
    },
    productInfoView: {
        flex: 0.475,
        marginRight: 16,
        width: SCREEN_WIDTH,
        height: SCREEN_HEIGHT
    },
    headerView: {
        backgroundColor: '#C6AFFF',
        height: 40,
        justifyContent: 'center'
    },
    headerText: {
        marginLeft: 16,
        fontSize: 20,
        fontFamily: 'Muli-Black'
    },
    productImageStyle: {
        marginTop: 8,
        marginLeft: 16,
        marginBottom: 40,
        height: SCREEN_HEIGHT - 70
    },
    backButtonImageStyle: {
        marginLeft: 32,
        height: 24,
        width: 24,
        backgroundColor: 'red'
    },
    subHeaderText: {
        fontFamily: 'Mulli-Regular',
        fontSize: 16,
        marginLeft: 16
    },
    instructionText: {
        fontFamily: 'Mulli-Regular',
        fontSize: 16,
        marginLeft: 16,
        marginBottom: 20
    },
    captureImageButtonView: {
        height: 48,
        borderRadius: 4,
        backgroundColor: Colors.digitYellow,
        marginTop: 2,
        flexDirection: 'row',
        justifyContent: 'center',
    },
    captureImageButtonText: {
        fontSize: 16,
        fontFamily: 'Muli-Black',
        alignSelf: 'center'
    },
    container: {
        flex: 1,
        // flexDirection: 'row',
        // backgroundColor: 'black',
    },
    preview: {
        flex: 1,
        justifyContent: 'flex-end',
        alignItems: 'center',
    },
    capture: {
        flex: 0,
        backgroundColor: '#fff',
        borderRadius: 5,
        padding: 15,
        paddingHorizontal: 20,
        alignSelf: 'flex-end',
        margin: 20,
        position: 'absolute'
    },
    flash: {
        flex: 0,
        backgroundColor: '#fff',
        borderRadius: 5,
        padding: 15,
        paddingHorizontal: 20,
        alignSelf: 'flex-end',
        margin: 20,
        position: 'absolute'
    },
    previewImageStyle: {
        width: SCREEN_WIDTH,
        height: SCREEN_HEIGHT
    },
    dateAndTimeText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        left: 1,
        bottom: 1
    },
    previewImageIconMainView: {
        flex: 0.05,
        backgroundColor: 'black'
    },
    tickMarkImageView: {
        flex: 0.6,
        justifyContent: 'flex-end'
    },
    tickMarkImageStyle: {
        width: 30,
        height: 30,
        backgroundColor: 'white',
        alignContent: 'flex-end',
        marginBottom: 20
    },
    crossImageView: {
        flex: 0.4,
        justifyContent: 'flex-end',
        marginBottom: 20
    },
    crossImageStyle: {
        width: 30,
        height: 30,
        backgroundColor: 'white',
        alignContent: 'flex-end'
    },
    cameraIconView: {
        flexDirection: 'row',
        justifyContent: 'center',
        width: SCREEN_WIDTH,
        position: 'absolute'
    },
    infoScrollView: {
        marginTop: 40,
        height: SCREEN_HEIGHT - 200
    },
    subHeaderTextView: {
        height: 40,
        marginTop: 8
    },
    backButtonImageView: {
        backgroundColor: '#C6AFFF',
        height: 40,
        justifyContent: 'center',
        marginLeft: 16
    },
    latLongText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        left: 1,
    },
    digitEdgeText: {
        position: 'absolute',
        fontSize: 20,
        color: Colors.digitYellow,
        right: 1,
    }


});